#include <ggi/ggiart.h>
/* gcc test1.c -o test1 -lart_lgpl -lggi -lggiart */

int main() {

  
  ArtVpath box[6];
  ggi_visual_t vis;
  ggi_mode mode;
  ggi_color color;

  struct ggiart_buffer_s b1;
  ggiart_svp_t    svp;
  int dxdy[2],i,j;

  struct ggiart_rop_s rops;
  struct ggiart_rop_s rops2;
  
  rops.rop=GGIART_ROP_COLOR;
  rops.arg1=(void*)(&color);
  rops2.rop=GGIART_ROP_TEXTURE;
  rops2.arg1=(void*)(&b1);
  rops2.arg2=(void*)(&dxdy);

  ggiInit();
  ggiartInit();
  vis=ggiOpen(NULL);
  
  ggiCheckGraphMode(vis,GGI_AUTO,GGI_AUTO,GGI_AUTO,GGI_AUTO,GGI_AUTO,&mode);
  ggiSetMode(vis,&mode);
  
  ggiartAttach(vis);
  
  ggiAddFlags(vis, GGIFLAG_ASYNC);

  color.r=0xffff; color.g=0xffff; color.b=0xffff;
  ggiSetGCForeground(vis,ggiMapColor(vis,&color));
  ggiFillscreen(vis);
  ggiFlush(vis);


  svp = art_svp_vpath_stroke(art_vpath_new_circle(100,150,75),
			     ART_PATH_STROKE_JOIN_MITER,
			     ART_PATH_STROKE_CAP_SQUARE,10,4,7);
  color.r=0x0; color.g=0x8fff; color.b=0x0; color.a=0x8fff;
  ggiartRenderSVP(vis,svp,NULL,&rops);
  ggiFlush(vis);
  ggiGetc(vis);

  b1.width=20;
  b1.height=20;
  b1.pixels=malloc(sizeof(*b1.pixels)*b1.width*b1.height);
  for(i=0;i<b1.width;i++)
    for(j=0;j<b1.height;j++) {
      b1.pixels[j*b1.width+i].r=0xffff;
      b1.pixels[j*b1.width+i].g=0xffff*((j<b1.height/2)&&(i<b1.height/2)||(j>=b1.height/2)&&(i>=b1.height/2));
      b1.pixels[j*b1.width+i].b=0xffff*((j<b1.height/2)&&(i<b1.height/2)||(j>=b1.height/2)&&(i>=b1.height/2));
      b1.pixels[j*b1.width+i].a=0x8fff;
      
    }
  dxdy[0]=0;
  dxdy[1]=0;
  svp = art_svp_vpath_stroke(art_vpath_new_circle(90,90,75),
			     ART_PATH_STROKE_JOIN_MITER,
			     ART_PATH_STROKE_CAP_SQUARE,20,4,7);
  ggiartRenderSVP(vis,svp,NULL,&rops2);
  ggiFlush(vis);
  ggiGetc(vis);

  for(i=0;i<b1.width;i++)
    for(j=0;j<b1.height;j++) {
      b1.pixels[j*b1.width+i].r=0xffff*((j<b1.height/2)&&(i<b1.height/2)||(j>=b1.height/2)&&(i>=b1.height/2));
      b1.pixels[j*b1.width+i].g=0xffff*((j<b1.height/2)&&(i<b1.height/2)||(j>=b1.height/2)&&(i>=b1.height/2));
      b1.pixels[j*b1.width+i].b=0xffff;
      b1.pixels[j*b1.width+i].a=0x6fff;
      
    }
  svp = art_svp_vpath_stroke(art_vpath_new_circle(180,95,75),
			     ART_PATH_STROKE_JOIN_MITER,
			     ART_PATH_STROKE_CAP_SQUARE,25,4,7);
  ggiartRenderSVP(vis,svp,NULL,&rops2);


  ggiFlush(vis);
  
  /*ggiFlush(vis);*/
  ggiGetc(vis);

  box[0].code=ART_MOVETO;
  box[0].x=20;
  box[0].y=30;
  box[3].code=ART_LINETO;
  box[3].x=330;
  box[3].y=80;
  box[2].code=ART_LINETO;
  box[2].x=367.2;
  box[2].y=295.1;
  box[1].code=ART_LINETO;
  box[1].x=211;
  box[1].y=167.1;
  box[4].code=ART_LINETO;
  box[4].x=20;
  box[4].y=30;
  box[5].code=ART_END;

  svp = art_svp_from_vpath(box);
  color.r=0xffff; color.g=0xffff; color.b=0; color.a=0x6f00; 
  ggiartRenderSVP(vis,svp,NULL,&rops);

  svp = art_svp_vpath_stroke(box,
			     ART_PATH_STROKE_JOIN_MITER,
			     ART_PATH_STROKE_CAP_SQUARE,1,4,7);


  color.r=0; color.g=0; color.b=0; color.a=0xffff; 
  ggiartRenderSVP(vis,svp,NULL,&rops);

  ggiFlush(vis);
    
  /*ggiFlush(vis);*/
  ggiGetc(vis);


  box[0].code=ART_MOVETO;
  box[0].x=10;
  box[0].y=130;
  box[3].code=ART_LINETO;
  box[3].x=10;
  box[3].y=130;
  box[2].code=ART_LINETO;
  box[2].x=108;
  box[2].y=9;
  box[1].code=ART_LINETO;
  box[1].x=234;
  box[1].y=87;
  box[4].code=ART_END;

  svp = art_svp_from_vpath(box);
  color.r=0x0; color.g=0xffff; color.b=0x8fff; color.a=0x6f00; 
  ggiartRenderSVP(vis,svp,NULL,&rops);

  svp = art_svp_vpath_stroke(box,
			     ART_PATH_STROKE_JOIN_MITER,
			     ART_PATH_STROKE_CAP_SQUARE,1.2,4,7);


  color.r=0; color.g=0; color.b=0; color.a=0xffff; 
  ggiartRenderSVP(vis,svp,NULL,&rops);

  ggiFlush(vis);

  /*ggiFlush(vis);*/
  ggiGetc(vis);


  box[0].code=ART_MOVETO;
  box[0].x=67;
  box[0].y=247;
  box[3].code=ART_LINETO;
  box[3].x=67;
  box[3].y=247;
  box[2].code=ART_LINETO;
  box[2].x=54;
  box[2].y=11;
  box[1].code=ART_LINETO;
  box[1].x=123;
  box[1].y=191;
  box[4].code=ART_END;

  svp = art_svp_from_vpath(box);
  color.r=0xffff; color.g=0xd0d0; color.b=0x7272; color.a=0x6f00; 
  ggiartRenderSVP(vis,svp,NULL,&rops);

  svp = art_svp_vpath_stroke(box,
			     ART_PATH_STROKE_JOIN_MITER,
			     ART_PATH_STROKE_CAP_SQUARE,1.3,4,7);


  color.r=0x7c7c; color.g=5353; color.b=0; color.a=0xffff; 
  ggiartRenderSVP(vis,svp,NULL,&rops);

  ggiFlush(vis);

  /*ggiFlush(vis);*/
  ggiGetc(vis);

  

  ggiartDetach(vis);

  ggiClose(vis);
  ggiartExit();
  ggiExit();

  return 0;
}
